diff --git a/gdb/Makefile.in b/gdb/Makefile.in
index 70d7d50..6061e79 100644
--- a/gdb/Makefile.in
+++ b/gdb/Makefile.in
@@ -1106,6 +1106,7 @@ SFILES = \
 	gdb_obstack.c \
 	gdb_usleep.c \
 	gdbarch.c \
+	gdbarch-selftests.c \
 	gdbtypes.c \
 	gnu-v2-abi.c \
 	gnu-v3-abi.c \
@@ -1719,6 +1720,7 @@ COMMON_OBS = $(DEPFILES) $(CONFIG_OBS) $(YYOBJ) \
 	gdb_usleep.o \
 	gdb_vecs.o \
 	gdbarch.o \
+	gdbarch-selftests.o \
 	gdbtypes.o \
 	gnu-v2-abi.o \
 	gnu-v3-abi.o \
diff --git a/gdb/frame.c b/gdb/frame.c
index 18937d9..a30e0b3 100644
--- a/gdb/frame.c
+++ b/gdb/frame.c
@@ -1707,6 +1707,23 @@ select_frame (struct frame_info *fi)
     }
 }
 
+#if GDB_SELF_TEST
+struct frame_info *
+create_test_frame (struct regcache *regcache)
+{
+  struct frame_info *this_frame = XCNEW (struct frame_info);
+
+  sentinel_frame = create_sentinel_frame (NULL, regcache);
+  sentinel_frame->prev = this_frame;
+  sentinel_frame->prev_p = 1;;
+  this_frame->prev_arch.p = 1;
+  this_frame->prev_arch.arch = get_regcache_arch (regcache);
+  this_frame->next = sentinel_frame;
+
+  return this_frame;
+}
+#endif
+
 /* Create an arbitrary (i.e. address specified by user) or innermost frame.
    Always returns a non-NULL value.  */
 
diff --git a/gdb/frame.h b/gdb/frame.h
index 1d0644f..56cbd44 100644
--- a/gdb/frame.h
+++ b/gdb/frame.h
@@ -833,6 +833,14 @@ extern struct frame_info *deprecated_safe_get_selected_frame (void);
 
 extern struct frame_info *create_new_frame (CORE_ADDR base, CORE_ADDR pc);
 
+#if GDB_SELF_TEST
+
+/* Create a frame for unit test.  Its next frame is sentinel frame,
+   created from REGCACHE.  */
+
+extern struct frame_info *create_test_frame (struct regcache *regcache);
+#endif
+
 /* Return true if the frame unwinder for frame FI is UNWINDER; false
    otherwise.  */
 
diff --git a/gdb/gdbarch-selftests.c b/gdb/gdbarch-selftests.c
new file mode 100644
index 0000000..68ab0b7
--- /dev/null
+++ b/gdb/gdbarch-selftests.c
@@ -0,0 +1,159 @@
+/* Self tests for gdbarch for GDB, the GNU debugger.
+
+   Copyright (C) 2017 Free Software Foundation, Inc.
+
+   This file is part of GDB.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
+
+#include "defs.h"
+#if GDB_SELF_TEST
+#include "selftest.h"
+#include "selftest-arch.h"
+#include "inferior.h"
+
+namespace selftests {
+
+/* A read-write regcache which doesn't write the target.  */
+
+class regcache_test : public regcache
+{
+public:
+  explicit regcache_test (struct gdbarch *gdbarch)
+    : regcache (gdbarch, NULL, false)
+  {
+    set_ptid (inferior_ptid);
+
+    current_regcache.push_front (this);
+  }
+
+  void raw_write (int regnum, const gdb_byte *buf) override
+  {
+    raw_set_cached_value (regnum, buf);
+  }
+};
+
+/* Test gdbarch methods register_to_value and value_to_register.  */
+
+static void
+register_to_value_test (struct gdbarch *gdbarch)
+{
+  const struct builtin_type *builtin = builtin_type (gdbarch);
+  struct type *types[] =
+    {
+      builtin->builtin_void,
+      builtin->builtin_char,
+      builtin->builtin_short,
+      builtin->builtin_int,
+      builtin->builtin_long,
+      builtin->builtin_signed_char,
+      builtin->builtin_unsigned_short,
+      builtin->builtin_unsigned_int,
+      builtin->builtin_unsigned_long,
+      builtin->builtin_float,
+      builtin->builtin_double,
+      builtin->builtin_long_double,
+      builtin->builtin_complex,
+      builtin->builtin_double_complex,
+      builtin->builtin_string,
+      builtin->builtin_bool,
+      builtin->builtin_long_long,
+      builtin->builtin_unsigned_long_long,
+      builtin->builtin_int8,
+      builtin->builtin_uint8,
+      builtin->builtin_int16,
+      builtin->builtin_uint16,
+      builtin->builtin_int32,
+      builtin->builtin_uint32,
+      builtin->builtin_int64,
+      builtin->builtin_uint64,
+      builtin->builtin_int128,
+      builtin->builtin_uint128,
+      builtin->builtin_char16,
+      builtin->builtin_char32,
+    };
+
+  current_inferior()->gdbarch = gdbarch;
+
+  struct regcache *regcache = new regcache_test (gdbarch);
+  struct frame_info *frame = create_test_frame (regcache);
+  const int num_regs = (gdbarch_num_regs (gdbarch)
+			+ gdbarch_num_pseudo_regs (gdbarch));
+
+  SELF_CHECK (regcache == get_current_regcache ());
+
+  /* Test gdbarch methods register_to_value and value_to_register with
+     different combinations of register numbers and types.  */
+  for (const auto &type : types)
+    {
+      for (auto regnum = 0; regnum < num_regs; regnum++)
+	{
+	  if (gdbarch_convert_register_p (gdbarch, regnum, type))
+	    {
+	      std::vector<gdb_byte> expected (TYPE_LENGTH (type), 0);
+
+	      if (TYPE_CODE (type) == TYPE_CODE_FLT)
+		{
+		  DOUBLEST d = 1.25;
+
+		  /* Generate valid float format.  */
+		  floatformat_from_doublest (floatformat_from_type (type),
+					     &d, expected.data ());
+		}
+	      else
+		{
+		  for (auto j = 0; j < expected.size (); j++)
+		    expected[j] = (regnum + j) % 16;
+		}
+
+	      gdbarch_value_to_register (gdbarch, frame, regnum, type,
+					 expected.data ());
+
+	      /* Allocate two bytes more for overflow check.  */
+	      std::vector<gdb_byte> buf (TYPE_LENGTH (type) + 2, 0);
+	      int optim, unavail, ok;
+
+	      /* Set the fingerprint in the last two bytes.  */
+	      buf [TYPE_LENGTH (type)]= 'w';
+	      buf [TYPE_LENGTH (type) + 1]= 'l';
+	      ok = gdbarch_register_to_value (gdbarch, frame, regnum, type,
+					      buf.data (), &optim, &unavail);
+
+	      SELF_CHECK (ok);
+	      SELF_CHECK (!optim);
+	      SELF_CHECK (!unavail);
+
+	      SELF_CHECK (buf[TYPE_LENGTH (type)] == 'w');
+	      SELF_CHECK (buf[TYPE_LENGTH (type) + 1] == 'l');
+
+	      for (auto k = 0;
+		   k < std::min ((unsigned int) register_size (gdbarch, regnum),
+				 TYPE_LENGTH (type));
+		   k++)
+		SELF_CHECK (buf[k] == expected[k]);
+	    }
+	}
+    }
+}
+
+} // namespace selftests
+#endif /* GDB_SELF_TEST */
+
+void
+_initialize_gdbarch_selftests (void)
+{
+#if GDB_SELF_TEST
+  register_self_test_foreach_arch (selftests::register_to_value_test);
+#endif
+}
diff --git a/gdb/regcache.h b/gdb/regcache.h
index fdc47ba..11126e6 100644
--- a/gdb/regcache.h
+++ b/gdb/regcache.h
@@ -250,6 +250,11 @@ public:
   regcache (const regcache &) = delete;
   void operator= (const regcache &) = delete;
 
+  /* class regcache is only extended in unit test, so only mark it
+     virtual when selftest is enabled.  */
+#if GDB_SELF_TEST
+  virtual
+#endif
   ~regcache ()
   {
     xfree (m_registers);
@@ -269,6 +274,12 @@ public:
   void cooked_write (int regnum, const gdb_byte *buf);
 
   enum register_status raw_read (int regnum, gdb_byte *buf);
+
+  /* class regcache is only extended in unit test, so only mark it
+     virtual when selftest is enabled.  */
+#if GDB_SELF_TEST
+  virtual
+#endif
   void raw_write (int regnum, const gdb_byte *buf);
 
   enum register_status raw_read_signed (int regnum, LONGEST *val);